# 
# Author: 
# 
# Description:
#

import StdDraw
from Tile import Tile
import picture
import time

class Avatar :

    # Constructor for the avatar class
    #
    # Input parameters: x and y are the initial integer positions of the
    #                   avatar within the world
    #                   hp are the avatar's hit points, or health
    #                   damage is the damage caused by avatar
    #                   torch is the initial strength of the torch
    def __init__(self, x, y, hp, damage, torch):
        self.x = x                 # current x location
        self.y = y                 # current y location
        self.TORCH_DELTA = 0.5     # increment/decrement of torch power

        ##### ADD ATTRIBUTES HERE #####

    # Mutator method to set the avatar to a new location
    #
    # Input parameters are the new integer x and y position
    def setLocation(self, x, y):
        self.x = x
        self.y = y

    # Accessor method
    #
    # Returns the x position of the avatar
    def getX(self):
        return self.x
    
    # Accessor method
    #
    # Returns the y position of the avatar
    def getY(self):
        return self.y

    # Get the hit points left for the avatar
    #
    # Returns the hit points remaining
    def getHitPoints(self):

        ##### YOUR CODE HERE #####
        return 0
    
    # Accessor method
    #
    # Returns the current radius of the torch
    def getTorchRadius(self):
        return self.torch

    # Make our torch more powerful
    #
    # Increases the radius of the torch
    def increaseTorch(self):
        self.torch += self.TORCH_DELTA
    
    # Make our torch less powerful
    #
    # Decreases the radius of the torch
    def decreaseTorch(self):
        self.torch -= self.TORCH_DELTA
        if self.torch < 2.0:
            self.torch = 2.0

    # Draw the avatar
    #
    # Uses the avatar's current position to place and draw the avatar
    #    on the canvas
    def draw(self):
        drawX = (self.x + 0.5) * Tile.SIZE
        drawY = (self.y + 0.5) * Tile.SIZE
        StdDraw.picture(picture.Picture("avatar.gif"), drawX, drawY)

    # Reduce hit points by amount of damage a monster attack has caused
    #
    # Input: points, the integer amount of damage a monster attack causes
    def incurDamage(self, points):

        ##### YOUR CODE HERE #####
        pass

    # Get the amount of damage we cause when we attack
    #
    # Returns the integer value of damage
    def getDamage(self):

        ##### YOUR CODE HERE #####
        return 0

# Main code to test the avatar class    
if __name__ == "__main__":
    # Create an avatar at 5,5
    avatar = Avatar(5, 5, 20, 4, 4.0)
    print("%d %d %.1f" %(avatar.getX(), avatar.getY(), avatar.getTorchRadius()))
    # Change the avatar's position
    avatar.setLocation(1, 4)
    print("%d %d %.1f" %(avatar.getX(), avatar.getY(), avatar.getTorchRadius()))
    # Increase the torch radius
    avatar.increaseTorch()
    print("%d %d %.1f" %(avatar.getX(), avatar.getY(), avatar.getTorchRadius()))
    # Decrease the torch radius 6 times to make sure it doesn't go below 2.0
    for i in range(0, 6):
        avatar.decreaseTorch()
        print("%d %d %.1f" %(avatar.getX(), avatar.getY(), avatar.getTorchRadius()))
